Index: /trunk/sources/HeuristicLab.GP/3.3/FunctionLibraryEditor.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP/3.3/FunctionLibraryEditor.Designer.cs	(revision 2787)
+++ /trunk/sources/HeuristicLab.GP/3.3/FunctionLibraryEditor.Designer.cs	(revision 2788)
@@ -54,5 +54,4 @@
       this.functionDetailsGroupBox = new System.Windows.Forms.GroupBox();
       this.functionDetailsPanel = new System.Windows.Forms.Panel();
-      this.functionsComboBox = new System.Windows.Forms.ComboBox();
       this.initializationTabPage = new System.Windows.Forms.TabPage();
       this.initSplitContainer = new System.Windows.Forms.SplitContainer();
@@ -144,4 +143,5 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.functionsListView.Location = new System.Drawing.Point(6, 19);
+      this.functionsListView.MultiSelect = false;
       this.functionsListView.Name = "functionsListView";
       this.functionsListView.Size = new System.Drawing.Size(218, 475);
@@ -150,4 +150,5 @@
       this.functionsListView.View = System.Windows.Forms.View.List;
       this.functionsListView.SelectedIndexChanged += new System.EventHandler(this.functionsListView_SelectedIndexChanged);
+      this.functionsListView.MouseUp += new System.Windows.Forms.MouseEventHandler(this.functionsListView_MouseUp);
       this.functionsListView.KeyUp += new System.Windows.Forms.KeyEventHandler(this.functionsListView_KeyUp);
       this.functionsListView.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.functionsListView_ItemDrag);
@@ -178,5 +179,4 @@
       // 
       this.functionDetailsGroupBox.Controls.Add(this.functionDetailsPanel);
-      this.functionDetailsGroupBox.Controls.Add(this.functionsComboBox);
       this.functionDetailsGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
       this.functionDetailsGroupBox.Location = new System.Drawing.Point(0, 0);
@@ -192,17 +192,8 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.functionDetailsPanel.Location = new System.Drawing.Point(6, 46);
+      this.functionDetailsPanel.Location = new System.Drawing.Point(6, 19);
       this.functionDetailsPanel.Name = "functionDetailsPanel";
-      this.functionDetailsPanel.Size = new System.Drawing.Size(417, 477);
+      this.functionDetailsPanel.Size = new System.Drawing.Size(417, 504);
       this.functionDetailsPanel.TabIndex = 7;
-      // 
-      // functionsComboBox
-      // 
-      this.functionsComboBox.FormattingEnabled = true;
-      this.functionsComboBox.Location = new System.Drawing.Point(6, 19);
-      this.functionsComboBox.Name = "functionsComboBox";
-      this.functionsComboBox.Size = new System.Drawing.Size(178, 21);
-      this.functionsComboBox.TabIndex = 0;
-      this.functionsComboBox.SelectedIndexChanged += new System.EventHandler(this.functionsComboBox_SelectedIndexChanged);
       // 
       // initializationTabPage
@@ -385,5 +376,4 @@
     private System.Windows.Forms.SplitContainer splitContainer;
     private System.Windows.Forms.Panel functionDetailsPanel;
-    private System.Windows.Forms.ComboBox functionsComboBox;
     private System.Windows.Forms.GroupBox availableFunctionsGroupBox;
     private System.Windows.Forms.GroupBox functionDetailsGroupBox;
Index: /trunk/sources/HeuristicLab.GP/3.3/FunctionLibraryEditor.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP/3.3/FunctionLibraryEditor.cs	(revision 2787)
+++ /trunk/sources/HeuristicLab.GP/3.3/FunctionLibraryEditor.cs	(revision 2788)
@@ -57,8 +57,6 @@
       initListView.Items.Clear();
       functionsListView.Clear();
-      functionsComboBox.Items.Clear();
       foreach (IFunction fun in FunctionLibrary.Functions) {
         functionsListView.Items.Add(CreateListViewItem(fun));
-        functionsComboBox.Items.Add(fun);
         if (fun.Manipulator != null) {
           mutationListView.Items.Add(CreateListViewItem(fun));
@@ -134,14 +132,4 @@
       data.SetData("DragSource", functionsListView);
       DoDragDrop(data, DragDropEffects.Link);
-    }
-
-    private void functionsComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      if (functionsComboBox.SelectedItem != null) {
-        IFunction selectedFun = (IFunction)functionsComboBox.SelectedItem;
-        Control funView = (Control)selectedFun.CreateView();
-        funView.Dock = DockStyle.Fill;
-        functionDetailsPanel.Controls.Clear();
-        functionDetailsPanel.Controls.Add(funView);
-      }
     }
 
@@ -320,4 +308,14 @@
     }
     #endregion
+
+    private void functionsListView_MouseUp(object sender, MouseEventArgs e) {
+      if (functionsListView.SelectedItems.Count > 0) {
+        IFunction selectedFun = (IFunction)functionsListView.SelectedItems[0].Tag;
+        Control funView = (Control)selectedFun.CreateView();
+        funView.Dock = DockStyle.Fill;
+        functionDetailsPanel.Controls.Clear();
+        functionDetailsPanel.Controls.Add(funView);
+      }
+    }
   }
 }