Index: trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/NewMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/NewMenuItem.cs	(revision 2791)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/NewMenuItem.cs	(revision 2796)
@@ -23,5 +23,4 @@
 using System.Drawing;
 using System.Windows.Forms;
-using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.Optimizer.MenuItems {
@@ -37,5 +36,5 @@
     }
     public override Image Image {
-      get { return Resources.NewIcon; }
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.NewDocument; }
     }
     public override Keys ShortCutKeys {
Index: trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OpenMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OpenMenuItem.cs	(revision 2791)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OpenMenuItem.cs	(revision 2796)
@@ -23,5 +23,4 @@
 using System.Drawing;
 using System.Windows.Forms;
-using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.Optimizer.MenuItems {
@@ -37,5 +36,5 @@
     }
     public override Image Image {
-      get { return Resources.OpenIcon; }
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Open; }
     }
     public override Keys ShortCutKeys {
Index: trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAllMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAllMenuItem.cs	(revision 2791)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAllMenuItem.cs	(revision 2796)
@@ -25,5 +25,4 @@
 using System.Linq;
 using System.Windows.Forms;
-using HeuristicLab.Common.Resources;
 using HeuristicLab.Core;
 using HeuristicLab.MainForm;
@@ -41,5 +40,5 @@
     }
     public override Image Image {
-      get { return Resources.SaveAllIcon; }
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.SaveAll; }
     }
 
Index: trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveMenuItem.cs	(revision 2791)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveMenuItem.cs	(revision 2796)
@@ -24,5 +24,4 @@
 using System.Drawing;
 using System.Windows.Forms;
-using HeuristicLab.Common.Resources;
 using HeuristicLab.Core;
 using HeuristicLab.MainForm;
@@ -40,5 +39,5 @@
     }
     public override Image Image {
-      get { return Resources.SaveIcon; }
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Save; }
     }
     public override Keys ShortCutKeys {
Index: trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/NewToolBarItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/NewToolBarItem.cs	(revision 2791)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/NewToolBarItem.cs	(revision 2796)
@@ -21,5 +21,4 @@
 
 using System.Drawing;
-using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.Optimizer {
@@ -35,5 +34,5 @@
     }
     public override Image Image {
-      get { return Resources.NewIcon; }
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.NewDocument; }
     }
 
Index: trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/OpenToolBarItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/OpenToolBarItem.cs	(revision 2791)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/OpenToolBarItem.cs	(revision 2796)
@@ -21,5 +21,4 @@
 
 using System.Drawing;
-using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.Optimizer {
@@ -35,5 +34,5 @@
     }
     public override Image Image {
-      get { return Resources.OpenIcon; }
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Open; }
     }
 
Index: trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveAllToolBarItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveAllToolBarItem.cs	(revision 2791)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveAllToolBarItem.cs	(revision 2796)
@@ -24,5 +24,4 @@
 using System.Linq;
 using System.Windows.Forms;
-using HeuristicLab.Common.Resources;
 using HeuristicLab.Core;
 using HeuristicLab.MainForm;
@@ -40,5 +39,5 @@
     }
     public override Image Image {
-      get { return Resources.SaveAllIcon; }
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.SaveAll; }
     }
 
Index: trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveToolBarItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveToolBarItem.cs	(revision 2791)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveToolBarItem.cs	(revision 2796)
@@ -23,5 +23,4 @@
 using System.Drawing;
 using System.Windows.Forms;
-using HeuristicLab.Common.Resources;
 using HeuristicLab.Core;
 using HeuristicLab.MainForm;
@@ -39,5 +38,5 @@
     }
     public override Image Image {
-      get { return Resources.SaveIcon; }
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Save; }
     }
 